



/*
 * c# console Hexa
 * compile path:C:\Windows\Microsoft.NET\Framework64\v4.0.30319\csc.exe
 */


using System;
using System.IO;
using System.Timers;

namespace ConsoleHexa
{
	public class Program
	{
		const int MAPY=22;
		const int MAPX=20;

		static int[,] hexa = new int[MAPY, MAPX];
		static int[,] hexatmp = new int[MAPY, MAPX];
		static int[] __design = new int[3];
		static int xpos, ypos;
		static int score;

		static String formattedText;
		static Timer timer;

		static void Main(string[] args)
		{
			int ff, kk, jj;

			timer = new System.Timers.Timer();
			timer.Interval = 500;
			timer.Elapsed += new ElapsedEventHandler(timer_elapsed_func);
			timer.Start(); //timer.Stop();

			ConsoleKey key = ConsoleKey.NoName;

			init(ref hexa, ref xpos, ref ypos, ref __design);
			DrawHexa(hexa);

			while (true)
			{
				key = Console.ReadKey().Key;
				ff = 0;

				if (key == ConsoleKey.RightArrow)
				{
					kk = f_rightkey(ref hexa, ref xpos, ref ypos, ref __design);
				}
				else if (key == ConsoleKey.LeftArrow)
				{
					kk = f_leftkey(ref hexa, ref xpos, ref ypos, ref __design);
				}
				else if (key == ConsoleKey.Enter)
				{
					while (true)
					{
						kk = f_downkey(ref hexa, ref xpos, ref ypos, ref __design);
						if (kk == 0) break;

						DrawHexa(hexa);
					}

					while (true)
					{
						jj = 0;
						if (f_check_horizontal(ref hexa, ref score) == 0) jj++;
						if (f_check_vertical(ref hexa, ref score) == 0) jj++;
						if (f_check_left_to_right(ref hexa, ref score) == 0) jj++;
						if (f_check_right_to_left(ref hexa, ref score) == 0) jj++;

						if (jj == 4) break;
					}

					xpos = MAPX / 2;
					ypos = 0;

					Random ____rr = new Random();

					__design[0] = 1 + (____rr.Next() % 5);
					__design[1] = 1 + (____rr.Next() % 5);
					__design[2] = 1 + (____rr.Next() % 5);

					hexa[ypos + 0, xpos] = __design[0];
					hexa[ypos + 1, xpos] = __design[1];
					hexa[ypos + 2, xpos] = __design[2];

					score = 0;

					DrawHexa(hexa);
				}
				else if (key == ConsoleKey.Spacebar)
				{
					kk = f_spacekey(ref hexa, ref xpos, ref ypos, ref __design);
				}
				else if (key == ConsoleKey.Escape)
				{
				    ff = 100;
				    timer.Stop();

					return;
				}

				if (ff == 0)
			    {
				    DrawHexa(hexa);
			    }
			}
		}

		static void timer_elapsed_func(object sender, ElapsedEventArgs e)
		{
			int kk, jj;

			DrawHexa(hexa);

			kk = f_downkey(ref hexa, ref xpos, ref ypos, ref __design);

			if (kk == 0)
			{
				if (ypos == 0)
				{
					timer.Stop();
					//f_quitmsg(score);
					return;
				}
				else
				{
					while (true)
					{
						jj = 0;
						if (f_check_horizontal(ref hexa, ref score) == 0) jj++;
						if (f_check_vertical(ref hexa, ref score) == 0) jj++;
						if (f_check_left_to_right(ref hexa, ref score) == 0) jj++;
						if (f_check_right_to_left(ref hexa, ref score) == 0) jj++;
						if (jj == 4) break;
					}
				}
				xpos = MAPX / 2;
				ypos = 0;

				Random ____rr = new Random();

				__design[0] = 1 + (____rr.Next() % 5);
				__design[1] = 1 + (____rr.Next() % 5);
				__design[2] = 1 + (____rr.Next() % 5);

				hexa[ypos + 0, xpos] = __design[0];
				hexa[ypos + 1, xpos] = __design[1];
				hexa[ypos + 2, xpos] = __design[2];
			}
		}

		public static int f_rightkey(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			if (check(ref hexa, x + 1, y, 0) == 1)
			{
				hexa[y + 0, x] = 0;
				hexa[y + 1, x] = 0;
				hexa[y + 2, x] = 0;

				x = x + 1;

				hexa[y + 0, x] = __des[0];
				hexa[y + 1, x] = __des[1];
				hexa[y + 2, x] = __des[2];

				return 1;
			}
			else
			{
				return 0;
			}
		}

		public static int f_leftkey(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			if (check(ref hexa, x - 1, y, 0) == 1)
			{
				hexa[y + 0, x] = 0;
				hexa[y + 1, x] = 0;
				hexa[y + 2, x] = 0;

				x = x - 1;

				hexa[y + 0, x] = __des[0];
				hexa[y + 1, x] = __des[1];
				hexa[y + 2, x] = __des[2];

				return 1;
			}
			else
			{
				return 0;
			}
		}

		public static int f_downkey(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			if (check(ref hexa, x, y + 1, 1) == 1)
			{
				hexa[y + 0, x] = 0;
				hexa[y + 1, x] = 0;
				hexa[y + 2, x] = 0;

				y = y + 1;

				hexa[y + 0, x] = __des[0];
				hexa[y + 1, x] = __des[1];
				hexa[y + 2, x] = __des[2];

				return 1;
			}
			else
			{
				return 0;
			}
		}

		public static int f_enterkey(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			return 1;
		}

		public static int f_spacekey(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			int tmp;

			tmp = __des[0];
			__des[0] = __des[1];
			__des[1] = __des[2];
			__des[2] = tmp;

			hexa[y + 0, x] = __des[0];
			hexa[y + 1, x] = __des[1];
			hexa[y + 2, x] = __des[2];

			return 1;
		}

		public static int check(ref int[,] hexa, int x, int y, int idx)
		{
			int result;

			result = 0;
			if (idx == 0)
			{
				if (hexa[y + 0, x] > 0) result = 1;
				if (hexa[y + 1, x] > 0) result = 1;
				if (hexa[y + 2, x] > 0) result = 1;
			}
			if (idx == 1)
			{
				if (hexa[y + 2, x] > 0) result = 1;
			}
			if (result == 1) return -1;
			return 1;
		}

		public static void init(ref int[,] hexa, ref int x, ref int y, ref int[] __des)
		{
			int mm, hh;

			for (mm = 0; mm < MAPY; mm++)
			{
				for (hh = 0; hh < MAPX; hh++)
				{
					hexa[mm, hh] = 0;
				}
			}
			for (mm = 0; mm < MAPY; mm++)
			{
				hexa[mm, 0] = 10;
				hexa[mm, MAPX - 1] = 10;
			}
			for (hh = 0; hh < MAPX; hh++)
			{
				hexa[MAPY - 1, hh] = 10;
			}
			x = MAPX / 2;
			y = 0;

			Random ____rr = new Random();

			__des[0] = 1 + (____rr.Next() % 5);
			__des[1] = 1 + (____rr.Next() % 5);
			__des[2] = 1 + (____rr.Next() % 5);

			hexa[y + 0, x] = __des[0];
			hexa[y + 1, x] = __des[1];
			hexa[y + 2, x] = __des[2];

			score = 0;

			Console.Clear();
		}

		public static void f_delete_column(ref int[,] hexa, int x, int y)
		{
			int hh;

			for (hh = y; hh >= 1; hh--)
			{
				hexa[hh, x] = hexa[(hh - 1), x];
			}
		}

		public static int f_check_horizontal(ref int[,] hexa, ref int sc)
		{
			int mm, hh, dd, idx;

			for (mm = 0; mm < MAPY - 1; mm++)
			{
				for (hh = 1; hh < MAPX - 3; hh++)
				{
					idx = 0;
					while (true)
					{
						if (hexa[mm, hh + idx] != 0)
						{
							if (hexa[mm, hh + idx] == hexa[mm, hh + idx + 1])
							{
								idx = idx + 1;
							}
							else break;
						}
						else break;
					}
					if (idx >= 2)
					{
						sc++;
						for (dd = hh; dd <= hh + idx; dd++)
						{
							f_delete_column(ref hexa, dd, mm);
						}
						return 1;
					}
				}
			}
			return 0;
		}

		public static int f_check_vertical(ref int[,] hexa, ref int sc)
		{
			int mm, hh, dd, idx;

			for (hh = 1; hh < MAPX - 1; hh++)
			{
				for (mm = MAPY - 2; mm >= 0; mm--)
				{
					idx = 0;
					while (true)
					{
						if (hexa[(mm - idx), hh] != 0)
						{
							if (hexa[(mm - idx), hh] == hexa[(mm - idx - 1), hh])
							{
								idx = idx + 1;
							}
							else break;
						}
						else break;
					}
					if (idx >= 2)
					{
						sc++;
						for (dd = mm; dd >= mm - idx; dd--)
						{
							f_delete_column(ref hexa, hh, mm);
						}
						return 1;
					}
				}
			}
			return 0;
		}

		public static int f_check_left_to_right(ref int[,] hexa, ref int sc)
		{
			int mm, hh, dd, idx;

			for (hh = 1; hh < MAPX - 1; hh++)
			{
				for (mm = 0; mm < MAPY - 1; mm++)
				{
					idx = 0;
					while (true)
					{
						if (hexa[(mm + idx), hh + idx] != 0)
						{
							if (hexa[(mm + idx), (hh + idx)] == hexa[(mm + idx + 1), (hh + idx + 1)])
							{
								idx = idx + 1;
							}
							else break;
						}
						else break;
					}
					if (idx >= 2)
					{
						sc++;
						for (dd = 0; dd <= idx; dd++)
						{
							f_delete_column(ref hexa, hh + dd, mm + dd);
						}
						return 1;
					}
				}
			}
			return 0;
		}

		public static int f_check_right_to_left(ref int[,] hexa, ref int sc)
		{
			int mm, hh, dd, idx;

			for (hh = MAPX - 2; hh >= 1; hh--)
			{
				for (mm = 0; mm < MAPY - 1; mm++)
				{
					idx = 0;
					while (true)
					{
						if (hexa[(mm + idx), hh - idx] != 0)
						{
							if (hexa[(mm + idx), (hh - idx)] == hexa[(mm + idx + 1), (hh - idx - 1)])
							{
								idx = idx + 1;
							}
							else break;
						}
						else break;
					}
					if (idx >= 2)
					{
						sc++;
						for (dd = 0; dd <= idx; dd++)
						{
							f_delete_column(ref hexa, hh - dd, mm + dd);
						}
						return 1;
					}
				}
			}
			return 0;
		}

		public static void DrawHexa(int[,] hexa)
        {
			formattedText = "";
			string[] realdesign = new string[6];

			realdesign[0] = "";
			realdesign[1] = "";
			realdesign[2] = "";
			realdesign[3] = "";
			realdesign[4] = "";
			realdesign[5] = "";

			int mm, hh;

			for(mm=0; mm<MAPY - 1; mm++)
            {
				for(hh=1; hh<MAPX-1; hh++)
                {
					if (hexa[mm, hh] == 0) formattedText = formattedText + realdesign[0];
					else if (hexa[mm, hh] == 1) formattedText = formattedText + realdesign[1];
					else if (hexa[mm, hh] == 2) formattedText = formattedText + realdesign[2];
					else if (hexa[mm, hh] == 3) formattedText = formattedText + realdesign[3];
					else if (hexa[mm, hh] == 4) formattedText = formattedText + realdesign[4];
					else if (hexa[mm, hh] == 5) formattedText = formattedText + realdesign[5];

				}
				formattedText = formattedText + "\n";
			}

			Console.BackgroundColor = ConsoleColor.Blue;
			Console.ForegroundColor = ConsoleColor.Yellow;

			Console.SetCursorPosition(0,1);
			Console.Write(formattedText);
		}
	}
}





